﻿Public Class Form1
    '動作モードenum
    Enum Cmode As Byte
        DC
        GATE
        TRIGGER
    End Enum

    '装置シリアル番号文字列
    Dim DevSerialStr As String

    '設定値類

    'SYNC OIUT
    Dim SyncOutClkN As UInteger             '現在の要求クロック周波数から生成された設定値
    Dim SYncOutFreqD As Double              'SyncOutClkNから算出されたクロック周波数
    'GROUP A
    Dim GrAMode As SetMode = SetMode.DC     '現在の動作モード
    Dim GrAClkN As UInteger                 '現在の要求クロック周波数から生成された設定値
    Dim GrAFreqD As Double                  'GrAClkNから算出されたクロック周波数
    Dim WavFreqA As Decimal = 100D          '波形生成設定の周波数を設定するNumericUpDownの値保存用
    Dim WavLenA As Decimal = 100D           '波形生成設定の波形データ数を設定するNumericUpDownの値保存用
    'GROUP B
    Dim GrBMode As SetMode = SetMode.DC     '現在の動作モード
    Dim GrBClkN As UInteger                 '現在の要求クロック周波数から生成された設定値
    Dim GrBFreqD As Double                  'GrBClkNから算出されたクロック周波数
    Dim WavFreqB As Decimal = 100D          '波形生成設定の周波数を設定するNumericUpDownの値保存用
    Dim WavLenB As Decimal = 100D           '波形生成設定の波形データ数を設定するNumericUpDownの値保存用

    'コンボボックスの設定値定義 ''''''''''''''/
    Const SEL_NONE As Integer = -1      '何も選択されていない
    'DIO設定 index
    Const DIO_IN As Integer = 0
    Const DIO_HIGH As Integer = 1
    Const DIO_LOW As Integer = 2
    'Sync Out 0 index
    Const SYNC0_HIGH As Integer = 0
    Const SYNC0_LOW As Integer = 1
    Const SYNC0_GATE_TRG As Integer = 2
    Const SYNC0_SYNCA As Integer = 3
    Const SYNC0_SYNCB As Integer = 4
    'Sync Out 1 index
    Const SYNC1_HIGH As Integer = 0
    Const SYNC1_LOW As Integer = 1
    Const SYNC1_CLOCK As Integer = 2
    Const SYNC1_SYNCA As Integer = 3
    Const SYNC1_SYNCB As Integer = 4

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OpenBtn.Enabled = True 'オープンボタンイネーブル
        CloseBtn.Enabled = False 'クローズボタンディセーブル

        '起動時は機能操作をディセーブルにする
        DIO_G.Enabled = False
        SYNCOUT_G.Enabled = False
        GROUPA_G.Enabled = False
        GROUPB_G.Enabled = False

        'コンボボックスのインデックスを初期化
        DIO_SEL0.SelectedIndex = 0
        DIO_SEL1.SelectedIndex = 0
        DIO_SEL2.SelectedIndex = 0
        DIO_SEL3.SelectedIndex = 0
        DIO_SEL4.SelectedIndex = 0
        DIO_SEL5.SelectedIndex = 0
        DIO_SEL6.SelectedIndex = 0
        DIO_SEL7.SelectedIndex = 0
        GrARangeCh1.SelectedIndex = 0
        GrARangeCh2.SelectedIndex = 0
        GrBRangeCh3.SelectedIndex = 0
        GrBRangeCh4.SelectedIndex = 0
        SyncOutSel0.SelectedIndex = 0
        SyncOutSel1.SelectedIndex = 0

        'ラジオボタンの初期値を設定
        SyncOutFreq_kHz.Checked = True
        GrAModeDC.Checked = True
        GrAClkInt.Checked = True
        GrAGTInt.Checked = True
        GrAFreq_kHz.Checked = True
        GrAWavSin1.Checked = True
        GrAWavSin2.Checked = True
        GrAWavFreq_kHz.Checked = True
        GrBModeDC.Checked = True
        GrBClkInt.Checked = True
        GrBGTInt.Checked = True
        GrBFreq_kHz.Checked = True
        GrBWavSin3.Checked = True
        GrBWavSin4.Checked = True
        GrBWavFreq_kHz.Checked = True

        '数値入力の初期値を設定
        SyncOutClkFreq.Value = 100D
        SyncOutClkFreq.Minimum = 0.001D
        SyncOutClkFreq.Maximum = 1000D

        GrATrgModeCnt.Value = 1D
        GrATrgModeCnt.Minimum = 1D
        GrATrgModeCnt.Maximum = 65535D
        GrAClkFreq.Value = 100D
        GrAClkFreq.Minimum = 0.001D
        GrAClkFreq.Maximum = 1000D
        GrAStopStSpVol1.Value = 0D
        GrAStopStSpVol1.Minimum = -10D
        GrAStopStSpVol1.Maximum = 9.9998D
        GrAStopStSpVol2.Value = 0D
        GrAStopStSpVol2.Minimum = -10D
        GrAStopStSpVol2.Maximum = 9.9998D
        GrAWavAmp1.Value = 1D
        GrAWavAmp1.Maximum = 9.9998D
        GrAWavAmp1.Minimum = -10D
        GrAWavAmp2.Value = 1D
        GrAWavAmp2.Maximum = 9.9998D
        GrAWavAmp2.Minimum = -10D
        GrAWavFreq.Value = 1D
        GrAWavFreq.Minimum = 0.001D
        GrAWavFreq.Maximum = 1000D

        GrBTrgModeCnt.Value = 1D
        GrBTrgModeCnt.Minimum = 1D
        GrBTrgModeCnt.Maximum = 65535D
        GrBClkFreq.Value = 100D
        GrBClkFreq.Minimum = 0.001D
        GrBClkFreq.Maximum = 1000D
        GrBStopStSpVol3.Value = 0D
        GrBStopStSpVol3.Minimum = -10D
        GrBStopStSpVol3.Maximum = 9.9998D
        GrBStopStSpVol4.Value = 0D
        GrBStopStSpVol4.Minimum = -10D
        GrBStopStSpVol4.Maximum = 9.9998D
        GrBWavAmp3.Value = 1D
        GrBWavAmp3.Maximum = 9.9998D
        GrBWavAmp3.Minimum = -10D
        GrBWavAmp4.Value = 1D
        GrBWavAmp4.Maximum = 9.9998D
        GrBWavAmp4.Minimum = -10D
        GrBWavFreq.Value = 1D
        GrBWavFreq.Minimum = 0.001D
        GrBWavFreq.Maximum = 1000D

    End Sub

    Private Sub OpenBtn_Click(sender As Object, e As EventArgs) Handles OpenBtn.Click
        DevSerialStr = SerialNum.Value.ToUShort().ToString("D4")
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Connect(DevSerialStr) 'デバイスの接続処理
        If (retcode = 0) Then '接続が出来たらコントロールの表示状態を変える
            DIO_G.Enabled = True
            SYNCOUT_G.Enabled = True
            GROUPA_G.Enabled = True
            GROUPB_G.Enabled = True
            OpenBtn.Enabled = False
            CloseBtn.Enabled = True
            SerialNum.Enabled = False
            Me.ControlBox = False
            IOCheckTimer.Enabled = True
            GrACheckTimer.Enabled = True
            GrBCheckTimer.Enabled = True
            DigitalIOGroupInit()        'Digial I/O関係の初期化
            SyncOutGroupInit()          'SyncOut関係の初期化
            GroupAGroupInit()           'GroupA Control関係の初期化
            GroupBGroupInit()           'GroupB Control関係の初期化
        Else
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub CloseBtn_Click(sender As Object, e As EventArgs) Handles CloseBtn.Click
        '切断時コントロールの表示状態を変える
        IOCheckTimer.Enabled = False
        GrACheckTimer.Enabled = False
        GrBCheckTimer.Enabled = False

        DIO_G.Enabled = False
        SYNCOUT_G.Enabled = False
        GROUPA_G.Enabled = False
        GROUPB_G.Enabled = False
        OpenBtn.Enabled = True
        CloseBtn.Enabled = False
        SerialNum.Enabled = True
        Me.ControlBox = True
        TUSB0416DAM.TUSB0416DAM_DisConnect(DevSerialStr)   '接続解除
    End Sub

    ' Digital I/O 関連処理
    ' ディレクションビットと出力ビットを装置から読み出してから現在の
    ' 値として表示に反映させる
    ' 接続時の処理
    Private Function SelDIOState(ByVal dbit As Boolean, ByVal iobit As Boolean) As Byte
        If (dbit) Then          '方向ビットがTrue(出力)で
            If (iobit) Then     '出力ビットがTrue(1)なら
                Return DIO_HIGH '出力High
            Else                '出力ビットがFalse(0)なら
                Return DIO_LOW  '出力 Low
            End If
        Else                    '方向ビットがFalse(入力)なら
            Return DIO_IN       '入力
        End If
    End Function
    Private Sub ChkDIO_State()
        Dim retcode As UInteger
        Dim IO_Dir As Byte
        Dim IO_Out As Byte
        retcode = TUSB0416DAM.TUSB0416DAM_Dio_Dir_R(DevSerialStr, IO_Dir)  ' 入出力方向の読み込み
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
            Return
        End If
        retcode = TUSB0416DAM.TUSB0416DAM_Dio_Out_R(DevSerialStr, IO_Out)  ' 出力設定ビットの読み込み
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
            Return
        End If

        ' 画面コントロールに反映させる
        DIO_SEL0.SelectedIndex = SelDIOState(IO_Dir.IsBitSet0, IO_Out.IsBitSet0)
        DIO_SEL1.SelectedIndex = SelDIOState(IO_Dir.IsBitSet1, IO_Out.IsBitSet1)
        DIO_SEL2.SelectedIndex = SelDIOState(IO_Dir.IsBitSet2, IO_Out.IsBitSet2)
        DIO_SEL3.SelectedIndex = SelDIOState(IO_Dir.IsBitSet3, IO_Out.IsBitSet3)
        DIO_SEL4.SelectedIndex = SelDIOState(IO_Dir.IsBitSet4, IO_Out.IsBitSet4)
        DIO_SEL5.SelectedIndex = SelDIOState(IO_Dir.IsBitSet5, IO_Out.IsBitSet5)
        DIO_SEL6.SelectedIndex = SelDIOState(IO_Dir.IsBitSet6, IO_Out.IsBitSet6)
        DIO_SEL7.SelectedIndex = SelDIOState(IO_Dir.IsBitSet7, IO_Out.IsBitSet7)

    End Sub

    ' Digital I/O 関連処理
    ' 入力状態をチェックして表示する
    Private Sub ChkDIO_In()
        Dim IO_In As Byte
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Dio_In(DevSerialStr, IO_In)   ' 入力状態を読み込む
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
            Return
        End If

        ' 画面への反映　Highなら明るい緑、Lowなら暗い緑にする
        DIO_IN0.BackColor = If(IO_In.IsBitSet0(), Color.LightGreen, Color.DarkGreen)
        DIO_IN1.BackColor = If(IO_In.IsBitSet1(), Color.LightGreen, Color.DarkGreen)
        DIO_IN2.BackColor = If(IO_In.IsBitSet2(), Color.LightGreen, Color.DarkGreen)
        DIO_IN3.BackColor = If(IO_In.IsBitSet3(), Color.LightGreen, Color.DarkGreen)
        DIO_IN4.BackColor = If(IO_In.IsBitSet4(), Color.LightGreen, Color.DarkGreen)
        DIO_IN5.BackColor = If(IO_In.IsBitSet5(), Color.LightGreen, Color.DarkGreen)
        DIO_IN6.BackColor = If(IO_In.IsBitSet6(), Color.LightGreen, Color.DarkGreen)
        DIO_IN7.BackColor = If(IO_In.IsBitSet7(), Color.LightGreen, Color.DarkGreen)
    End Sub

    ' Didital I/O 関連処理
    ' 現在のIO設定を出力に反映する
    Private Sub SetDIO_Out()
        If (Not DIO_G.Enabled) Then
            Return
        End If

        Dim IO_Dir As Byte = 0     ' 入出力方向設定      0が入力
        Dim IO_Out As Byte = 0     ' 出力High Low設定    0がLow

        ' 画面コントロールから読み込む

        If (DIO_SEL0.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet0()
        If (DIO_SEL1.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet1()
        If (DIO_SEL2.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet2()
        If (DIO_SEL3.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet3()
        If (DIO_SEL4.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet4()
        If (DIO_SEL5.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet5()
        If (DIO_SEL6.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet6()
        If (DIO_SEL7.SelectedIndex <> DIO_IN) Then IO_Dir.BitSet7()

        If (DIO_SEL0.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet0()
        If (DIO_SEL1.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet1()
        If (DIO_SEL2.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet2()
        If (DIO_SEL3.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet3()
        If (DIO_SEL4.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet4()
        If (DIO_SEL5.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet5()
        If (DIO_SEL6.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet6()
        If (DIO_SEL7.SelectedIndex = DIO_HIGH) Then IO_Out.BitSet7()

        Dim retcode As UInteger
        retcode = TUSB0416DAM.TUSB0416DAM_Dio_Dir(DevSerialStr, IO_Dir)     ' 入出力を設定
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
        retcode = TUSB0416DAM.TUSB0416DAM_Dio_Out(DevSerialStr, IO_Out)     ' High Low を設定
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub


    'Digital I/O コントロールグループの初期化をする
    Private Sub DigitalIOGroupInit()
        ChkDIO_State()
        ChkDIO_In()
    End Sub

    ' Sync Out 関連処理
    ' コントロールグループの表示状態を設定する
    ' 要求周波数から実際に設定される周波数を算出したり
    ' 設定値に応じて各コントロールのイネーブル設定を変更する
    Private Sub SyncOutGroupEnControls()

        If (Not SYNCOUT_G.Enabled) Then
            Return
        End If

        ' 表示のイネーブルコントロール
        SyncOutClkFreq.Enabled = (SyncOutSel1.SelectedIndex = SYNC1_CLOCK)
        SyncOutFreq_kHz.Enabled = SyncOutClkFreq.Enabled
        SyncOutFreq_Hz.Enabled = SyncOutClkFreq.Enabled
        SYNCOUT_GTCONT_P.Enabled = (SyncOutSel0.SelectedIndex = SYNC0_GATE_TRG)

        If (SyncOutSelGOff.Checked) Then
            SyncOutTrgBtn.Enabled = True
        Else
            SyncOutTrgBtn.Enabled = False
        End If

        ' クロック周波数の表示
        If (Etc.GetClockSetting(CType(SyncOutClkFreq.Value, Double), SyncOutFreq_kHz.Checked, SyncOutClkN)) Then ' クロック設定値の算出
            SYncOutFreqD = Etc.GetActualFrequency(SyncOutClkN)         ' 設定値から周波数の算出
            SyncOutActFreq.Text = Etc.GetFrequencyStr(SYncOutFreqD)    ' 周波数から周波数を表す文字列の生成
            SyncOutSetBtn.Enabled = True
        Else
            SyncOutClkFreq.AlartColor(True)
            SyncOutSetBtn.Enabled = False
        End If

        ' ボタンの色
        SyncOutSetBtn.BackColor = Color.Salmon
    End Sub

    ' Sync Out 関連処理
    ' コントロールグループの初期化をする
    Private Sub SyncOutGroupInit()

        If (SyncOutSel0.SelectedIndex = SEL_NONE) Then SyncOutSel0.SelectedIndex = SYNC0_HIGH
        If (SyncOutSel1.SelectedIndex = SEL_NONE) Then SyncOutSel1.SelectedIndex = SYNC1_HIGH

        Dim GateEn As GateSt
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_GateSet_R(DevSerialStr, ModuleN.Ext, GateEn) ' ゲート出力の状態を読み出す
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else

            If (GateEn = GateSt.GOn) Then
                SyncOutSelGOn.Checked = True
            Else
                SyncOutSelGOff.Checked = True
            End If
        End If
        SyncOutGroupEnControls()
        SyncOutSetBtn.AwakeColor(True)
    End Sub

    ' Group A 関連処理
    ' クロック周波数のチェックと実際に設定される周波数の表示
    ' 問題が無ければ trueを返す
    Private Function FreqChkA() As Boolean

        Dim clkresult As Boolean = True
        Dim wavresult As Boolean = True

        ' クロック設定値のチェック
        If (GROUPA_CLKGEN_G.Enabled) Then

            clkresult = Etc.GetClockSetting(CType(GrAClkFreq.Value, Double), GrAFreq_kHz.Checked, GrAClkN) ' 希望周波数に一番近くなる設定値(整数)を生成
            If (clkresult) Then
                GrAFreqD = Etc.GetActualFrequency(GrAClkN)         ' 設定値で設定した時に実際に設定される周波数(希望と丁度同じとは限らない)を取得
                GrAActFreq.Text = Etc.GetFrequencyStr(GrAFreqD)    ' その周波数を文字列で取得
            End If
            GrAClkFreq.AlartColor(Not clkresult)
        End If

        ' 波形周波数のチェック
        If (GROUPA_IMAGE_GEN_G.Enabled And GrAClkInt.Checked) Then

            Dim len As Integer
            wavresult = Etc.GetWaveLength(CType(GrAWavFreq.Value, Double), GrAWavFreq_kHz.Checked, GrAFreqD, len) ' 波形に必要なデータ長を取得
            If (wavresult) Then

                GrAWavActFreq.Text = Etc.GetFrequencyStr(GrAFreqD / CType(len, Double)) ' 設定整数値から再度周波数に計算しなおして周波数文字列を得る
                GrAWavFreq.AlartColor(False)
            End If
            GrAWavFreq.AlartColor(Not wavresult)
        Else
            GrAWavFreq.AlartColor(False)
        End If
        Return (clkresult And wavresult)
    End Function

    ' Group B 関連処理
    ' クロック周波数のチェックと実際に設定される周波数の表示
    ' 問題が無ければ trueを返す
    Private Function FreqChkB() As Boolean

        Dim clkresult As Boolean = True
        Dim wavresult As Boolean = True

        ' クロック設定値のチェック
        If (GROUPB_CLKGEN_G.Enabled) Then

            clkresult = Etc.GetClockSetting(CType(GrBClkFreq.Value, Double), GrBFreq_kHz.Checked, GrBClkN) ' 希望周波数に一番近くなる設定値(整数)を生成
            If (clkresult) Then
                GrBFreqD = Etc.GetActualFrequency(GrBClkN)         ' 設定値で設定した時に実際に設定される周波数(希望と丁度同じとは限らない)を取得
                GrBActFreq.Text = Etc.GetFrequencyStr(GrBFreqD)    ' その周波数を文字列で取得
            End If
            GrBClkFreq.AlartColor(Not clkresult)
        End If

        ' 波形周波数のチェック
        If (GROUPB_IMAGE_GEN_G.Enabled And GrBClkInt.Checked) Then

            Dim len As Integer
            wavresult = Etc.GetWaveLength(CType(GrBWavFreq.Value, Double), GrBWavFreq_kHz.Checked, GrBFreqD, len) ' 波形に必要なデータ長を取得
            If (wavresult) Then

                GrBWavActFreq.Text = Etc.GetFrequencyStr(GrBFreqD / CType(len, Double)) ' 設定整数値から再度周波数に計算しなおして周波数文字列を得る
                GrBWavFreq.AlartColor(False)
            End If
            GrBWavFreq.AlartColor(Not wavresult)
        Else
            GrBWavFreq.AlartColor(False)
        End If
        Return (clkresult And wavresult)
    End Function

    ' Group A 関連処理
    ' 電圧設定チェック
    ' 問題が無ければ trueを返す
    Private Function VoltChkA() As Boolean

        Dim err As Boolean = False

        Dim RangeCh1 As RangeSel = CType(GrARangeCh1.SelectedIndex, RangeSel)   ' ch1 レンジ
        Dim RangeCh2 As RangeSel = CType(GrARangeCh2.SelectedIndex, RangeSel)   ' ch2 レンジ
        Dim DCV1 As Double = CType(GrAOffsetDCCh1.Value, Double)                ' ch1 直流オフセット電圧
        Dim DCV2 As Double = CType(GrAOffsetDCCh2.Value, Double)                ' ch2 直流オフセット電圧
        Dim AMP1 As Double = CType(GrAWavAmp1.Value, Double)                    ' ch1 振幅電圧
        Dim AMP2 As Double = CType(GrAWavAmp2.Value, Double)                    ' ch2 振幅電圧
        Dim STPV1 As Double = CType(GrAStopStSpVol1.Value, Double)              ' ch1 停止電圧
        Dim STPV2 As Double = CType(GrAStopStSpVol2.Value, Double)              ' ch2 停止電圧

        ' 直流電圧設定値がレンジ内に入っているか確認
        err = err Or GrAOffsetDCCh1.AlartColor(Not Etc.VoltRangeChk(RangeCh1, DCV1))
        err = err Or GrAOffsetDCCh2.AlartColor(Not Etc.VoltRangeChk(RangeCh2, DCV2))

        If (Not GrAModeDC.Checked) Then ' 直流出力ではない場合

            ' 波形のピーク電圧がレンジ内に入っているか確認
            err = err Or GrAWavAmp1.AlartColor((Not Etc.VoltRangeChk(RangeCh1, DCV1 + AMP1)) Or (Not Etc.VoltRangeChk(RangeCh1, DCV1 - AMP1)))
            err = err Or GrAWavAmp2.AlartColor((Not Etc.VoltRangeChk(RangeCh2, DCV2 + AMP2)) Or (Not Etc.VoltRangeChk(RangeCh2, DCV2 - AMP2)))

            ' 停止電圧の設定が有効ならば、停止電圧がレンジ内に入っているか確認
            If (GrAStopStSpChk1.Checked) Then
                err = err Or GrAStopStSpVol1.AlartColor(Not Etc.VoltRangeChk(RangeCh1, STPV1))
            End If
            If (GrAStopStSpChk2.Checked) Then
                err = err Or GrAStopStSpVol2.AlartColor(Not Etc.VoltRangeChk(RangeCh2, STPV2))
            End If

        End If

        Return (Not err)
    End Function

    ' Group B 関連処理
    ' 電圧設定チェック
    ' 問題が無ければ trueを返す
    Private Function VoltChkB() As Boolean

        Dim err As Boolean = False

        Dim RangeCh3 As RangeSel = CType(GrBRangeCh3.SelectedIndex, RangeSel)   ' Ch3 レンジ
        Dim RangeCh4 As RangeSel = CType(GrBRangeCh4.SelectedIndex, RangeSel)   ' Ch4 レンジ
        Dim DCV3 As Double = CType(GrBOffsetDCCh3.Value, Double)                ' Ch3 直流オフセット電圧
        Dim DCV4 As Double = CType(GrBOffsetDCCh4.Value, Double)                ' Ch4 直流オフセット電圧
        Dim AMP3 As Double = CType(GrBWavAmp3.Value, Double)                    ' Ch3 振幅電圧
        Dim AMP4 As Double = CType(GrBWavAmp4.Value, Double)                    ' Ch4 振幅電圧
        Dim STPV3 As Double = CType(GrBStopStSpVol3.Value, Double)              ' Ch3 停止電圧
        Dim STPV4 As Double = CType(GrBStopStSpVol4.Value, Double)              ' Ch4 停止電圧

        ' 直流電圧設定値がレンジ内に入っているか確認
        err = err Or GrBOffsetDCCh3.AlartColor(Not Etc.VoltRangeChk(RangeCh3, DCV3))
        err = err Or GrBOffsetDCCh4.AlartColor(Not Etc.VoltRangeChk(RangeCh4, DCV4))

        If (Not GrBModeDC.Checked) Then ' 直流出力ではない場合

            ' 波形のピーク電圧がレンジ内に入っているか確認
            err = err Or GrBWavAmp3.AlartColor((Not Etc.VoltRangeChk(RangeCh3, DCV3 + AMP3)) Or (Not Etc.VoltRangeChk(RangeCh3, DCV3 - AMP3)))
            err = err Or GrBWavAmp4.AlartColor((Not Etc.VoltRangeChk(RangeCh4, DCV4 + AMP4)) Or (Not Etc.VoltRangeChk(RangeCh4, DCV4 - AMP4)))

            ' 停止電圧の設定が有効ならば、停止電圧がレンジ内に入っているか確認
            If (GrBStopStSpChk3.Checked) Then
                err = err Or GrBStopStSpVol3.AlartColor(Not Etc.VoltRangeChk(RangeCh3, STPV3))
            End If
            If (GrBStopStSpChk4.Checked) Then
                err = err Or GrBStopStSpVol4.AlartColor(Not Etc.VoltRangeChk(RangeCh4, STPV4))
            End If

        End If

        Return (Not err)
    End Function

    ' Group A 関連処理
    ' コントロールグループの表示状態を設定する
    Private Sub GroupAGroupEnControls()
        If (Not GROUPA_G.Enabled) Then
            Return
        End If

        Dim err As Boolean = False

        ' 表示のイネーブルコントロール
        GROUPA_CLK_G.Enabled = Not GrAModeDC.Checked
        GROUPA_GT_G.Enabled = Not GrAModeDC.Checked
        GROUPA_GMODE_G.Enabled = GrAModeGate.Checked
        GrAGModeInv.Enabled = GrAGTExt.Checked
        GROUPA_TMODE_G.Enabled = GrAModeTrg.Checked
        GROUPA_CLKGEN_G.Enabled = Not GrAModeDC.Checked And GrAClkInt.Checked
        GrATrgModeCnt.Enabled = Not GrATrgModeInf.Checked
        GROUPA_STPST_G.Enabled = Not GrAModeDC.Checked
        GrAStopStSpVol1.Enabled = GrAStopStSpChk1.Checked
        GrAStopStSpVol2.Enabled = GrAStopStSpChk2.Checked
        GROUPA_CH1_WGEN_G.Enabled = Not GrAModeDC.Checked
        GROUPA_CH2_WGEN_G.Enabled = Not GrAModeDC.Checked
        GROUPA_IMAGE_GEN_G.Enabled = Not GrAModeDC.Checked
        GROUPA_GCONT_G.Enabled = GrAModeGate.Checked And GrAGTInt.Checked
        GrAStartTrgBtn.Enabled = GrAModeTrg.Checked And GrAGTInt.Checked
        GrAStopBtn.Enabled = GrAModeTrg.Checked

        ' クロック周波数のチェックと表示
        err = err Or Not FreqChkA()

        ' 電圧レベルチェック
        err = err Or Not VoltChkA()

        ' ボタンの表示
        GrASetBtn.AwakeColor(True)
        GrASetBtn.Enabled = Not err
    End Sub

    ' Group B 関連処理
    ' コントロールグループの表示状態を設定する
    Private Sub GroupBGroupEnControls()
        If (Not GROUPB_G.Enabled) Then
            Return
        End If

        Dim Err As Boolean = False

        ' 表示のイネーブルコントロール
        GROUPB_CLK_G.Enabled = Not GrBModeDC.Checked
        GROUPB_GT_G.Enabled = Not GrBModeDC.Checked
        GROUPB_GMODE_G.Enabled = GrBModeGate.Checked
        GrBGModeInv.Enabled = GrBGTExt.Checked
        GROUPB_TMODE_G.Enabled = GrBModeTrg.Checked
        GROUPB_CLKGEN_G.Enabled = Not GrBModeDC.Checked
        GrBTrgModeCnt.Enabled = Not GrBTrgModeInf.Checked
        GROUPB_STPST_G.Enabled = Not GrBModeDC.Checked
        GrBStopStSpVol3.Enabled = GrBStopStSpChk3.Checked
        GrBStopStSpVol4.Enabled = GrBStopStSpChk4.Checked
        GROUPB_CH3_WGEN_G.Enabled = Not GrBModeDC.Checked
        GROUPB_CH4_WGEN_G.Enabled = Not GrBModeDC.Checked
        GROUPB_IMAGE_GEN_G.Enabled = Not GrBModeDC.Checked
        GROUPB_GCONT_G.Enabled = GrBModeGate.Checked And GrBGTInt.Checked
        GrBStartTrgBtn.Enabled = GrBModeTrg.Checked And GrBGTInt.Checked
        GrBStopBtn.Enabled = GrBModeTrg.Checked

        ' クロック周波数のチェックと表示
        Err = Err Or Not FreqChkB()

        ' 電圧レベルチェック
        Err = Err Or Not VoltChkB()

        ' ボタンの表示
        GrBSetBtn.AwakeColor(True)
        GrBSetBtn.Enabled = Not Err
    End Sub

    ' Group A
    ' 構造体から設定を読み出して画面表示に反映する
    Private Sub SetSettingsA(ByVal sets As stSettings)

        GrAMode = sets.Mode
        Select Case (sets.Mode)
            Case SetMode.DC
                GrAModeDC.Checked = True
            Case SetMode.Gate
                GrAModeGate.Checked = True
            Case SetMode.Trg
                GrAModeTrg.Checked = True
        End Select

        If (sets.ClkSel = SigSrc.Internal) Then : GrAClkInt.Checked = True
        Else GrAClkExt.Checked = True : End If
        If (sets.GTSel = SigSrc.Internal) Then : GrAGTInt.Checked = True
        Else GrAGTExt.Checked = True : End If
        If (sets.ExGtInv = SigInv.Invert) Then : GrAGModeInv.Checked = True
        Else GrAGModeInv.Checked = False : End If
        If (sets.Rstc = RestartPos.Zero) Then : GrAGModeStart.Checked = True
        Else GrAGModeStart.Checked = False : End If
        If (sets.FStat(0) = FinState.SpecificValue) Then : GrAStopStSpChk1.Checked = True
        Else GrAStopStSpChk1.Checked = False : End If
        If (sets.FStat(1) = FinState.SpecificValue) Then : GrAStopStSpChk2.Checked = True
        Else GrAStopStSpChk2.Checked = False : End If
        GrAStopStSpVol1.Value = Etc.DacCodeToVolt(sets.FVal(0), CType(GrARangeCh1.SelectedIndex, RangeSel))
        GrAStopStSpVol2.Value = Etc.DacCodeToVolt(sets.FVal(1), CType(GrARangeCh2.SelectedIndex, RangeSel))
        If (sets.RepCyc = 0) Then : GrATrgModeInf.Checked = True
        Else GrATrgModeCnt.Value = sets.RepCyc : End If
    End Sub

    ' Group B
    ' 構造体から設定を読み出して画面表示に反映する
    Private Sub SetSettingsB(ByVal sets As stSettings)

        GrBMode = sets.Mode
        Select Case (sets.Mode)
            Case SetMode.DC
                GrBModeDC.Checked = True
            Case SetMode.Gate
                GrBModeGate.Checked = True
            Case SetMode.Trg
                GrBModeTrg.Checked = True
        End Select

        If (sets.ClkSel = SigSrc.Internal) Then : GrBClkInt.Checked = True
        Else GrBClkExt.Checked = True : End If
        If (sets.GTSel = SigSrc.Internal) Then : GrBGTInt.Checked = True
        Else GrBGTExt.Checked = True : End If
        If (sets.ExGtInv = SigInv.Invert) Then : GrBGModeInv.Checked = True
        Else GrBGModeInv.Checked = False : End If
        If (sets.Rstc = RestartPos.Zero) Then : GrBGModeStart.Checked = True
        Else GrBGModeStart.Checked = False : End If
        If (sets.FStat(0) = FinState.SpecificValue) Then : GrBStopStSpChk3.Checked = True
        Else GrBStopStSpChk3.Checked = False : End If
        If (sets.FStat(1) = FinState.SpecificValue) Then : GrBStopStSpChk4.Checked = True
        Else GrBStopStSpChk4.Checked = False : End If
        GrBStopStSpVol3.Value = Etc.DacCodeToVolt(sets.FVal(0), CType(GrBRangeCh3.SelectedIndex, RangeSel))
        GrBStopStSpVol4.Value = Etc.DacCodeToVolt(sets.FVal(1), CType(GrBRangeCh4.SelectedIndex, RangeSel))
        If (sets.RepCyc = 0) Then : GrBTrgModeInf.Checked = True
        Else GrBTrgModeCnt.Value = sets.RepCyc : End If
    End Sub

    ' Group A 関連処理
    ' コントロールグループの初期化をする
    Private Sub GroupAGroupInit()
        Dim retcode As UInteger

        ' 設定構造体を読み込む
        Dim Damset As stSettings = New stSettings
        retcode = TUSB0416DAM.TUSB0416DAM_DacGrSet_R(DevSerialStr, ModuleN.A, Damset)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            SetSettingsA(Damset)
        End If
        ' 設定されているレンジを読み込んで画面に反映させる
        Dim Range As RangeSel
        ' ch1 レンジ
        retcode = TUSB0416DAM.TUSB0416DAM_RangeSet_R(DevSerialStr, ChSel.Ch1, Range)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            Dim r As Integer = CType(Range, Integer)
            GrARangeCh1.SelectedIndex = r
        End If
        ' ch2 レンジ
        retcode = TUSB0416DAM.TUSB0416DAM_RangeSet_R(DevSerialStr, ChSel.Ch2, Range)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            GrARangeCh2.SelectedIndex = CType(Range, Integer)
        End If

        GroupAGroupEnControls()    ' コントロールの表示設定
        GrASetBtn.AwakeColor(True)

        ' ゲートコントロールの設定値を読み込んで画面に反映させる
        Dim GateEn As GateSt
        retcode = TUSB0416DAM.TUSB0416DAM_GateSet_R(DevSerialStr, ModuleN.A, GateEn)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            If (GateEn = GateSt.GOn) Then
                GrAGateOn.Checked = True
            Else
                GrAGateOff.Checked = True
            End If
        End If
    End Sub

    ' Group B 関連処理
    ' コントロールグループの初期化をする
    Private Sub GroupBGroupInit()
        Dim retcode As UInteger

        ' 設定構造体を読み込む
        Dim Damset As stSettings = New stSettings
        retcode = TUSB0416DAM.TUSB0416DAM_DacGrSet_R(DevSerialStr, ModuleN.B, Damset)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            SetSettingsB(Damset)
        End If

        ' 設定されているレンジを読み込んで画面に反映させる
        Dim Range As RangeSel
        ' ch3 レンジ
        retcode = TUSB0416DAM.TUSB0416DAM_RangeSet_R(DevSerialStr, ChSel.Ch3, Range)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            GrBRangeCh3.SelectedIndex = CType(Range, Integer)
        End If
        ' ch4 レンジ
        retcode = TUSB0416DAM.TUSB0416DAM_RangeSet_R(DevSerialStr, ChSel.Ch4, Range)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            GrBRangeCh4.SelectedIndex = CType(Range, Integer)
        End If

        GroupBGroupEnControls()    ' コントロールの表示設定
        GrBSetBtn.AwakeColor(True)

        ' ゲートコントロールの設定値を読み込んで画面に反映させる
        Dim GateEn As GateSt
        retcode = TUSB0416DAM.TUSB0416DAM_GateSet_R(DevSerialStr, ModuleN.B, GateEn)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        Else
            If (GateEn = GateSt.GOn) Then
                GrAGateOn.Checked = True
            Else
                GrAGateOff.Checked = True
            End If
        End If
    End Sub

    ' Group A Group B 関連処理
    ' 動作設定
    ' 画面の設定を読み出して設定構造体に値を設定して
    ' モジュール毎に設定を行う
    Private Sub SetModeSetting(ByVal MSel As ModuleN)
        Dim retcode As UInteger
        Dim sets As stSettings  ' 設定構造体
        ReDim sets.FStat(1)     ' 構造体要素の配列作成
        ReDim sets.FVal(1)      ' 構造体要素の配列作成

        ' 画面から設定値を構造体要素に設定する
        If (MSel = ModuleN.A) Then
            sets.Mode = If(GrAModeDC.Checked, SetMode.DC, If(GrAModeGate.Checked, SetMode.Gate, SetMode.Trg))
            sets.ClkSel = If(GrAClkInt.Checked, SigSrc.Internal, SigSrc.External)
            sets.GTSel = If(GrAGTInt.Checked, SigSrc.Internal, SigSrc.External)
            sets.ExGtInv = If(GrAGModeInv.Checked, SigInv.Invert, SigInv.NonInvert)
            sets.Rstc = If(GrAGModeStart.Checked, RestartPos.Zero, RestartPos.Conti)
            sets.xOption = 0
            sets.FStat(0) = If(GrAStopStSpChk1.Checked, FinState.SpecificValue, FinState.LastValue)
            sets.FStat(1) = If(GrAStopStSpChk2.Checked, FinState.SpecificValue, FinState.LastValue)
            sets.FVal(0) = Etc.DoubleToDacCode(GrAStopStSpVol1.Value.ToDouble(), CType(GrARangeCh1.SelectedIndex, RangeSel))
            sets.FVal(1) = Etc.DoubleToDacCode(GrAStopStSpVol2.Value.ToDouble(), CType(GrARangeCh2.SelectedIndex, RangeSel))
            sets.RepCyc = If(GrATrgModeInf.Checked, 0, GrATrgModeCnt.Value.ToUShort())

            GrAMode = sets.Mode
        Else

            sets.Mode = If(GrBModeDC.Checked, SetMode.DC, If(GrBModeGate.Checked, SetMode.Gate, SetMode.Trg))
            sets.ClkSel = If(GrBClkInt.Checked, SigSrc.Internal, SigSrc.External)
            sets.GTSel = If(GrBGTInt.Checked, SigSrc.Internal, SigSrc.External)
            sets.ExGtInv = If(GrBGModeInv.Checked, SigInv.Invert, SigInv.NonInvert)
            sets.Rstc = If(GrBGModeStart.Checked, RestartPos.Zero, RestartPos.Conti)
            sets.xOption = 0
            sets.FStat(0) = If(GrBStopStSpChk3.Checked, FinState.SpecificValue, FinState.LastValue)
            sets.FStat(1) = If(GrBStopStSpChk4.Checked, FinState.SpecificValue, FinState.LastValue)
            sets.FVal(0) = Etc.DoubleToDacCode(GrBStopStSpVol3.Value.ToDouble(), CType(GrBRangeCh3.SelectedIndex, RangeSel))
            sets.FVal(1) = Etc.DoubleToDacCode(GrBStopStSpVol4.Value.ToDouble(), CType(GrBRangeCh4.SelectedIndex, RangeSel))
            sets.RepCyc = If(GrBTrgModeInf.Checked, 0, GrBTrgModeCnt.Value.ToUShort())

            GrBMode = sets.Mode
        End If

        ' 設定を実行する
        retcode = TUSB0416DAM.TUSB0416DAM_DacGrSet(DevSerialStr, MSel, sets)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    ' Group A Group B 関連処理
    ' クロック生成器設定
    Private Sub SetClockGen(ByVal MSel As ModuleN)
        Dim retcode As UInteger
        Dim DivideN As UInteger
        If (MSel = ModuleN.A) Then
            DivideN = GrAClkN - 1  ' 除数は1小さい値を設定する
        Else
            DivideN = GrBClkN - 1  ' 除数は1小さい値を設定する
        End If

        retcode = TUSB0416DAM.TUSB0416DAM_Clock_Gen(DevSerialStr, MSel, DivideN) ' クロックを設定する
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    ' Group A Group B 関連処理
    ' レンジの設定
    Private Sub SetRange(ByVal ch As ChSel)
        Dim retcode As UInteger
        Dim range As RangeSel
        Select Case (ch)
            Case ChSel.Ch1 : range = CType(GrARangeCh1.SelectedIndex, RangeSel)
            Case ChSel.Ch2 : range = CType(GrARangeCh2.SelectedIndex, RangeSel)
            Case ChSel.Ch3 : range = CType(GrBRangeCh3.SelectedIndex, RangeSel)
            Case ChSel.Ch4 : range = CType(GrBRangeCh4.SelectedIndex, RangeSel)
            Case Else : range = RangeSel.Unipol5
        End Select

        retcode = TUSB0416DAM.TUSB0416DAM_RangeSet(DevSerialStr, ch, range) '　レンジを設定する
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    ' Group A Group B 関連処理
    ' 直流電圧設定
    Private Sub SetDCVolt(ByVal ch As ChSel)

        ' 各チャンネルのレンジを直流電圧値から設定すべき値を計算する
        Dim dcv As UShort
        Select Case (ch)
            Case ChSel.Ch1 : dcv = Etc.DoubleToDacCode(GrAOffsetDCCh1.Value.ToDouble(), CType(GrARangeCh1.SelectedIndex, RangeSel))
            Case ChSel.Ch2 : dcv = Etc.DoubleToDacCode(GrAOffsetDCCh2.Value.ToDouble(), CType(GrARangeCh2.SelectedIndex, RangeSel))
            Case ChSel.Ch3 : dcv = Etc.DoubleToDacCode(GrBOffsetDCCh3.Value.ToDouble(), CType(GrBRangeCh3.SelectedIndex, RangeSel))
            Case ChSel.Ch4 : dcv = Etc.DoubleToDacCode(GrBOffsetDCCh4.Value.ToDouble(), CType(GrBRangeCh4.SelectedIndex, RangeSel))
            Case Else : dcv = 0
        End Select
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_DcValSet(DevSerialStr, ch, dcv) ' 出力値を設定する
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    ' Group A Group B 関連処理
    ' 波形設定
    ' 周期波形モードの時に波形を設定する
    Private Sub SetWavImage(ByVal MSel As ModuleN)
        Dim retcode As UInteger
        Dim wimage1() As UShort ' ch1(Or ch3)波形イメージ配列
        Dim wimage2() As UShort ' ch2(Or ch4)波形イメージ配列
        Dim Len As Integer      ' 波形長

        If (MSel = ModuleN.A) Then
            Dim shape As Etc.WShape '波形種類
            Dim Range As RangeSel   '電圧レンジ
            Dim offset As Double    'オフセット電圧
            Dim amp As Double       ' 振幅電圧

            If (GrAClkInt.Checked) Then
                Etc.GetWaveLength(CType(GrAWavFreq.Value, Double), GrAWavFreq_kHz.Checked, GrAFreqD, Len) ' 波形に必要なデータ長を取得
            Else
                Len = GrAWavFreq.Value.ToInteger()
            End If

            ' ch1 波形イメージ生成
            shape = If(GrAWavSin1.Checked, Etc.WShape.Sin, If(GrAWavRect1.Checked, Etc.WShape.Rectangle, Etc.WShape.Triangle))
            Range = CType(GrARangeCh1.SelectedIndex, RangeSel)
            offset = GrAOffsetDCCh1.Value.ToDouble()
            amp = GrAWavAmp1.Value.ToDouble()
            ReDim wimage1(Len - 1)
            Etc.WaveImageGen(shape, Range, offset, amp, wimage1, Len)

            ' ch2 波形イメージ生成
            shape = If(GrAWavSin2.Checked, Etc.WShape.Sin, If(GrAWavRect2.Checked, Etc.WShape.Rectangle, Etc.WShape.Triangle))
            Range = CType(GrARangeCh2.SelectedIndex, RangeSel)
            offset = GrAOffsetDCCh2.Value.ToDouble()
            amp = GrAWavAmp2.Value.ToDouble()
            ReDim wimage2(Len - 1)
            Etc.WaveImageGen(shape, Range, offset, amp, wimage2, Len)

        Else
            Dim shape As Etc.WShape '波形種類
            Dim Range As RangeSel   ' 電圧レンジ
            Dim offset As Double    ' オフセット電圧
            Dim amp As Double       ' 振幅電圧

            If (GrBClkInt.Checked) Then
                Etc.GetWaveLength(CType(GrBWavFreq.Value, Double), GrBWavFreq_kHz.Checked, GrBFreqD, Len) ' 波形に必要なデータ長を取得
            Else
                Len = GrBWavFreq.Value.ToInteger()
            End If

            ' ch3 波形イメージ生成
            shape = If(GrBWavSin3.Checked, Etc.WShape.Sin, If(GrBWavRect3.Checked, Etc.WShape.Rectangle, Etc.WShape.Triangle))
            Range = CType(GrBRangeCh3.SelectedIndex, RangeSel)
            offset = GrBOffsetDCCh3.Value.ToDouble()
            amp = GrBWavAmp3.Value.ToDouble()
            ReDim wimage1(Len - 1)
            Etc.WaveImageGen(shape, Range, offset, amp, wimage1, Len)

            ' ch4 波形イメージ生成
            shape = If(GrBWavSin4.Checked, Etc.WShape.Sin, If(GrBWavRect4.Checked, Etc.WShape.Rectangle, Etc.WShape.Triangle))
            Range = CType(GrBRangeCh4.SelectedIndex, RangeSel)
            offset = GrBOffsetDCCh4.Value.ToDouble()
            amp = GrBWavAmp4.Value.ToDouble()
            ReDim wimage2(Len - 1)
            Etc.WaveImageGen(shape, Range, offset, amp, wimage2, Len)
        End If

        ' 波形イメージの書き込み
        retcode = TUSB0416DAM.TUSB0416DAM_WavImgSet(DevSerialStr, MSel, wimage1, wimage2, Len)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub DigitalIOChange(sender As Object, e As EventArgs) Handles DIO_SEL7.SelectedIndexChanged, DIO_SEL6.SelectedIndexChanged, DIO_SEL5.SelectedIndexChanged, DIO_SEL4.SelectedIndexChanged, DIO_SEL3.SelectedIndexChanged, DIO_SEL2.SelectedIndexChanged, DIO_SEL1.SelectedIndexChanged, DIO_SEL0.SelectedIndexChanged
        SetDIO_Out()   ' Digital I/O 出力を設定する
    End Sub

    Private Sub IOCheckTimer_Tick(sender As Object, e As EventArgs) Handles IOCheckTimer.Tick
        ChkDIO_In()    ' Digital I/O 入力状態を確認する
    End Sub

    Private Sub SyncOutChange(sender As Object, e As EventArgs) Handles SyncOutSel1.SelectedIndexChanged, SyncOutSel0.SelectedIndexChanged, SyncOutFreq_kHz.CheckedChanged, SyncOutFreq_Hz.CheckedChanged, SyncOutClkFreq.ValueChanged
        SyncOutGroupEnControls()   ' Sync Out 表示状態を更新する
    End Sub

    Private Sub SyncOutSelGOff_CheckedChanged(sender As Object, e As EventArgs) Handles SyncOutSelGOff.CheckedChanged
        ' Sync Out ゲート出力をOffに設定する
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_GateSet(DevSerialStr, ModuleN.Ext, GateSt.GOff)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub SyncOutSelGOn_CheckedChanged(sender As Object, e As EventArgs) Handles SyncOutSelGOn.CheckedChanged
        ' Sync Out ゲート出力をOnに設定する
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_GateSet(DevSerialStr, ModuleN.Ext, GateSt.GOn)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub SyncOutSetBtn_Click(sender As Object, e As EventArgs) Handles SyncOutSetBtn.Click
        ' Sync Out 出力選択を設定する
        Dim OutSel0 As Byte = SyncOutSel0.SelectedIndex.ToByte()  ' Sync Out 0 設定
        Dim OutSel1 As Byte = SyncOutSel1.SelectedIndex.ToByte()  ' Sync Out 1 設定
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Exs_Sel(DevSerialStr, OutSel0, OutSel1)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If

        ' 出力クロックを設定する
        If (SyncOutSel1.SelectedIndex = SYNC1_CLOCK) Then
            retcode = TUSB0416DAM.TUSB0416DAM_Clock_Gen(DevSerialStr, ModuleN.Ext, (SyncOutClkN - 1))
            If (retcode <> 0) Then
                MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
            End If
        End If
        SyncOutSetBtn.UseVisualStyleBackColor = True
    End Sub

    Private Sub SyncOutTrgBtn_Click(sender As Object, e As EventArgs) Handles SyncOutTrgBtn.Click
        ' Sync Out 1 トリガ信号を発生させる
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Trigger(DevSerialStr, ModuleN.Ext, TrgSel.TStart)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub GroupAChange(sender As Object, e As EventArgs) Handles GrAWavTriang2.CheckedChanged, GrAWavTriang1.CheckedChanged, GrAWavSin2.CheckedChanged, GrAWavSin1.CheckedChanged, GrAWavRect2.CheckedChanged, GrAWavRect1.CheckedChanged, GrAWavFreq_kHz.CheckedChanged, GrAWavFreq_Hz.CheckedChanged, GrAModeTrg.CheckedChanged, GrAModeGate.CheckedChanged, GrAModeDC.CheckedChanged, GrAGTInt.CheckedChanged, GrAGTExt.CheckedChanged, GrAFreq_kHz.CheckedChanged, GrAFreq_Hz.CheckedChanged, GrAWavFreq.ValueChanged, GrAWavAmp2.ValueChanged, GrAWavAmp1.ValueChanged, GrATrgModeInf.CheckedChanged, GrATrgModeCnt.ValueChanged, GrAStopStSpVol2.ValueChanged, GrAStopStSpVol1.ValueChanged, GrAStopStSpChk2.CheckedChanged, GrAStopStSpChk1.CheckedChanged, GrARangeCh2.SelectedValueChanged, GrARangeCh1.SelectedValueChanged, GrAOffsetDCCh2.ValueChanged, GrAOffsetDCCh1.ValueChanged, GrAGModeStart.CheckedChanged, GrAGModeInv.CheckedChanged, GrAClkFreq.ValueChanged
        GroupAGroupEnControls()    ' Group A 表示状態を更新する
    End Sub

    Private Sub GroupAClkSrcChange(sender As Object, e As EventArgs) Handles GrAClkInt.CheckedChanged, GrAClkExt.CheckedChanged
        ' クロックソースが変更された時に実行する

        If (GrAClkInt.Checked) Then ' 内部クロックに変更
            GrAWavGenFreqLbl.Text = "Freq."
            GrAWavFreq.DecimalPlaces = 3
            GrAWavFreq.Maximum = 1000D
            GrAWavFreq.Minimum = 0.001D
            GrAWavFreq.Value = WavFreqA
            GrAWavGenFreqP.Visible = True
        Else                 '外部クロックに変更
            GrAWavGenFreqLbl.Text = "Leng."
            GrAWavFreq.DecimalPlaces = 0
            GrAWavFreq.Maximum = 262144D
            GrAWavFreq.Minimum = 2D
            GrAWavFreq.Value = WavLenA
            GrAWavGenFreqP.Visible = False
        End If
        GroupAGroupEnControls()
    End Sub

    Private Sub GrASetBtn_Click(sender As Object, e As EventArgs) Handles GrASetBtn.Click
        If (GrAClkInt.Checked) Then ' 内部クロック
            WavFreqA = GrAWavFreq.Value
        Else
            WavLenA = GrAWavFreq.Value
        End If

        ' 動作設定 ////
        SetModeSetting(ModuleN.A)

        ' クロック生成設定 ////
        If (GROUPA_CLKGEN_G.Enabled) Then
            SetClockGen(ModuleN.A)
        End If

        ' レンジ設定　////
        SetRange(ChSel.Ch1)
        SetRange(ChSel.Ch2)

        ' 直流電圧設定 Or 波形イメージ  書き込み ////
        If (GrAModeDC.Checked) Then ' 直流動作 The
            SetDCVolt(ChSel.Ch1)
            SetDCVolt(ChSel.Ch2)
        Else
            SetWavImage(ModuleN.A)
        End If

        GrASetBtn.AwakeColor(False)
    End Sub

    Private Sub GrAGateChange(sender As Object, e As EventArgs) Handles GrAGateOn.CheckedChanged, GrAGateOff.CheckedChanged
        ' Group A のゲート出力を設定する
        Dim GateEn As GateSt = If(GrAGateOn.Checked, GateSt.GOn, GateSt.GOff)
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_GateSet(DevSerialStr, ModuleN.A, GateEn)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub GrAStartTrgBtn_Click(sender As Object, e As EventArgs) Handles GrAStartTrgBtn.Click
        ' Group A のスタートトリガを出力する
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Trigger(DevSerialStr, ModuleN.A, TrgSel.TStart)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub GrAStopBtn_Click(sender As Object, e As EventArgs) Handles GrAStopBtn.Click
        ' Group A のトリガ波形出力を停止する
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Trigger(DevSerialStr, ModuleN.A, TrgSel.TStop)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub GrACheckTimer_Tick(sender As Object, e As EventArgs) Handles GrACheckTimer.Tick
        Dim retcode As UInteger
        ' Group A タイマーチェック
        ' 周期波形出力時の出力状態(出力中かどうか)を表示する

        Select Case (GrAMode)
            Case SetMode.DC       ' 直流出力時
                GrAWavGenInd.BackColor = SystemColors.Control
            Case SetMode.Gate     ' ゲート出力時
                Dim GateEn As GateSt  ' ゲート出力設定時
                retcode = TUSB0416DAM.TUSB0416DAM_GateSet_R(DevSerialStr, ModuleN.A, GateEn)
                If (retcode <> 0) Then
                    MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
                ElseIf (GateEn = GateSt.GOn) Then
                    GrAWavGenInd.BackColor = Color.LightBlue
                Else
                    GrAWavGenInd.BackColor = SystemColors.Control
                End If
            Case SetMode.Trg      ' トリガ出力時
                Dim stat As TrgStat
                retcode = TUSB0416DAM.TUSB0416DAM_Trigger_Stat(DevSerialStr, ModuleN.A, stat)
                If (retcode <> 0) Then
                    MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
                ElseIf (stat = TrgStat.TRun) Then
                    GrAWavGenInd.BackColor = Color.LightBlue
                Else
                    GrAWavGenInd.BackColor = SystemColors.Control
                End If
        End Select
    End Sub

    Private Sub GroupBChange(sender As Object, e As EventArgs) Handles GrBWavTriang4.CheckedChanged, GrBWavTriang3.CheckedChanged, GrBWavSin4.CheckedChanged, GrBWavSin3.CheckedChanged, GrBWavRect4.CheckedChanged, GrBWavRect3.CheckedChanged, GrBWavFreq_kHz.CheckedChanged, GrBWavFreq_Hz.CheckedChanged, GrBModeTrg.CheckedChanged, GrBModeGate.CheckedChanged, GrBModeDC.CheckedChanged, GrBGTInt.CheckedChanged, GrBGTExt.CheckedChanged, GrBFreq_kHz.CheckedChanged, GrBFreq_Hz.CheckedChanged, GrBWavFreq.ValueChanged, GrBWavAmp4.ValueChanged, GrBWavAmp3.ValueChanged, GrBTrgModeInf.CheckedChanged, GrBTrgModeCnt.ValueChanged, GrBStopStSpVol4.ValueChanged, GrBStopStSpVol3.ValueChanged, GrBStopStSpChk4.CheckedChanged, GrBStopStSpChk3.CheckedChanged, GrBRangeCh4.SelectedValueChanged, GrBRangeCh3.SelectedValueChanged, GrBOffsetDCCh4.ValueChanged, GrBOffsetDCCh3.ValueChanged, GrBGModeStart.CheckedChanged, GrBGModeInv.CheckedChanged, GrBClkFreq.ValueChanged
        GroupBGroupEnControls()
    End Sub

    Private Sub GroupBClkSrcChange(sender As Object, e As EventArgs) Handles GrBClkInt.CheckedChanged, GrBClkExt.CheckedChanged
        If (GrBClkInt.Checked) Then ' 内部クロックに変更
            GrBWavGenFreqLbl.Text = "Freq."
            GrBWavFreq.DecimalPlaces = 3
            GrBWavFreq.Maximum = 1000D
            GrBWavFreq.Minimum = 0.001D
            GrBWavFreq.Value = WavFreqB
            GrBWavGenFreqP.Visible = True
        Else
            GrBWavGenFreqLbl.Text = "Leng."
            GrBWavFreq.DecimalPlaces = 0
            GrBWavFreq.Maximum = 262144D
            GrBWavFreq.Minimum = 2D
            GrBWavFreq.Value = WavLenB
            GrBWavGenFreqP.Visible = False
        End If
        GroupBGroupEnControls()
    End Sub

    Private Sub GrBSetBtn_Click(sender As Object, e As EventArgs) Handles GrBSetBtn.Click
        If (GrBClkInt.Checked) Then ' 内部クロック
            WavFreqB = GrBWavFreq.Value
        Else
            WavLenB = GrBWavFreq.Value
        End If

        ' 動作設定 ////
        SetModeSetting(ModuleN.B)

        ' クロック生成設定 ////
        If (GROUPB_CLKGEN_G.Enabled) Then
            SetClockGen(ModuleN.B)
        End If

        ' レンジ設定////
        SetRange(ChSel.Ch3)
        SetRange(ChSel.Ch4)

        ' 直流電圧設定 Or 波形イメージ  書き込み ////
        If (GrBModeDC.Checked) Then ' 直流動作
            SetDCVolt(ChSel.Ch3)
            SetDCVolt(ChSel.Ch4)
        Else
            SetWavImage(ModuleN.B)
        End If

        GrBSetBtn.AwakeColor(False)
    End Sub

    Private Sub GrBGateChange(sender As Object, e As EventArgs) Handles GrBGateOn.CheckedChanged, GrBGateOff.CheckedChanged
        ' Group B のゲート出力を設定する
        Dim GateEn As GateSt = If(GrBGateOn.Checked, GateSt.GOn, GateSt.GOff)
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_GateSet(DevSerialStr, ModuleN.B, GateEn)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub GrBStartTrgBtn_Click(sender As Object, e As EventArgs) Handles GrBStartTrgBtn.Click
        ' Group B のスタートトリガを出力する
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Trigger(DevSerialStr, ModuleN.B, TrgSel.TStart)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub GrBStopBtn_Click(sender As Object, e As EventArgs) Handles GrBStopBtn.Click
        ' Group B のトリガ波形出力を停止する
        Dim retcode As UInteger = TUSB0416DAM.TUSB0416DAM_Trigger(DevSerialStr, ModuleN.B, TrgSel.TStop)
        If (retcode <> 0) Then
            MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
        End If
    End Sub

    Private Sub GrBCheckTimer_Tick(sender As Object, e As EventArgs) Handles GrBCheckTimer.Tick
        Dim retcode As UInteger
        ' Group B タイマーチェック
        ' 周期波形出力時の出力状態(出力中かどうか)を表示する

        Select Case (GrBMode)
            Case SetMode.DC     ' 直流出力時
                GrBWavGenInd.BackColor = SystemColors.Control
            Case SetMode.Gate     ' ゲート出力時
                Dim GateEn As GateSt
                retcode = TUSB0416DAM.TUSB0416DAM_GateSet_R(DevSerialStr, ModuleN.B, GateEn)
                If (retcode <> 0) Then
                    MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
                ElseIf (GateEn = GateSt.GOn) Then
                    GrBWavGenInd.BackColor = Color.LightBlue
                Else
                    GrBWavGenInd.BackColor = SystemColors.Control
                End If
            Case SetMode.Trg      ' トリガ出力時
                Dim stat As TrgStat
                retcode = TUSB0416DAM.TUSB0416DAM_Trigger_Stat(DevSerialStr, ModuleN.B, stat)
                If (retcode <> 0) Then
                    MessageBox.Show(TUSB0416DAM.GetErrMessage(retcode))
                ElseIf (stat = TrgStat.TRun) Then
                    GrBWavGenInd.BackColor = Color.LightBlue
                Else
                    GrBWavGenInd.BackColor = SystemColors.Control
                End If
        End Select
    End Sub
End Class
